<?php
/*
Plugin Name: Hobo WP Googlebot Tracker
Plugin URI: http://www.hobo-web.co.uk/seo-blog/
Description: A Simple Plugin To Track GoogleBot Visits To Your Pages. Developed by <a href="http://www.hobo-web.co.uk/martin-gardner.htm" target="_blank">Martin Gardner</a> of <a href="http://www.hobo-web.co.uk/seo-blog/" target="_blank">Hobo-web</a>. 
Version: 1.0 Beta
Author: Hobo-Web
Author URI: http://www.hobo-web.co.uk/seo-blog/
*/
/*  Copyright 2009 Martin Gardner (email : martin.gardner@hobo-web.co.uk)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/


// SET OUR GLOBALS
global $wpdb;
global $wp_version;
global $hobo_wp_googlebot_tracker_db_version;
	
$hobo_wp_googlebot_tracker_db_version = '1.0';

// SECURITY
if (!defined('ABSPATH')) die("'God Dam It!' Access via WP-Admin ONLY! <strong>Ya Crazy Fool!</strong>");

define('WPHGBT_VERSION', '1.0 Beta');
define('WPHGBT_ABSPATH', WP_PLUGIN_DIR . '/' . plugin_basename( dirname(__FILE__) ).'/' );
define('WPHGBT_URLPATH', WP_PLUGIN_URL . '/' . plugin_basename( dirname(__FILE__) ).'/' );

// Exit Message on Error
$exit_msg  = __('Hobo wp googlebot tracker requires Wordpress 2.9.0 or newer. ');
$exit_msg .= __('<a href="http://codex.wordpress.org/Upgrading_Wordpress">!UPDATE NOW!</a>');

// Check our Current Wordpress version
if (version_compare($wp_version,"2.8.0","<"))
{
	exit ($exit_msg);
}


// Install and Remove actions
register_activation_hook(__FILE__, 'hobo_wp_googlebot_tracker_install');
register_deactivation_hook( __FILE__, 'hobo_wp_googlebot_tracker_remove' );




// Plugin Instalation
function hobo_wp_googlebot_tracker_install() {
	include('hobo-wp-googlebot-tracker-install.php');
}




// Plugin De-Activation
function hobo_wp_googlebot_tracker_remove() {
	include('hobo-wp-googlebot-tracker-remove.php');
}




// Admin CSS/JQuery
function hobo_wp_googlebot_tracker_admin_header() {
	include('hobo-wp-googlebot-tracker-adminhead.php');
}




// Our Dashboard Widget
function hobo_wp_googlebot_tracker_dashboard_widget_function() {
	include('hobo-wp-googlebot-tracker-widget.php');
} 




// Create the Options page
function hobo_wp_googlebot_tracker_options() {
	include('hobo-wp-googlebot-tracker-options.php');
}




// Create the function used in the action hook to add the dashboard widget
function hobo_wp_googlebot_tracker_add_dashboard_widgets() {
	wp_add_dashboard_widget('hobo_wp_googlebot_tracker_dashboard_widget', 'Hobo WP GoogleBot Tracker Statistics', 'hobo_wp_googlebot_tracker_dashboard_widget_function');	
}




// Create the admin menu options page
function hobo_wp_googlebot_tracker_settings_menu() {
  add_options_page('Hobo GoogleBot Settings', 'Hobo GoogleBot', 8, __FILE__, 'hobo_wp_googlebot_tracker_options');
}




// Grab a RSS feed and Display it, along with how many to display
function hobo_wp_googlebot_tracker_hobofeed($feed_url, $counter='10') {
	$content = file_get_contents($feed_url);
	$x = new SimpleXmlElement($content);
	
	echo "<ul>";
	$limit = $counter;
    for ($i = 0; $i<$limit; $i++) {
        $entry = $x->channel->item[$i];
        echo "<li><a href='$entry->link' title='$entry->title' target='_blank'>" . $entry->title . "</a></li>";
    }
	echo "</ul>";
}




// Assign the Code to the wp_footer on each page
function hobo_wp_googlebot_tracker_code() {
	include('hobo-wp-googlebot-tracker-code.php');
}




// Just shorten the text a little for small screens...
function shortText($str, $max, $rep = '...') {
  if(strlen($str) > $max) {
    $leave = $max - strlen($rep);
    return substr_replace($str, $rep, $leave);
  } else {
    return $str;
  }
}




// Show the Love Credit | wp-footer needs to be active in template
function hobo_wp_googlebot_credits()
{
	$options = get_option('hobo_wp_googlebot_tracker');
	$creditlink = $options['creditlink'];
	if($creditlink==1) {
?>
    	<div class="hobo_wp_googlebot_credits">Tracked by <a href="http://www.hobo-web.co.uk/seo-blog/index.php/googlebot-tracker/" target="_blank">Hobo</a></div>
<?php
	}// end if
}




// Plug Everything into Wordpress :)
$options = get_option('hobo_wp_googlebot_tracker');
if($options['dashwidget']!="0"){
	add_action('wp_dashboard_setup', 'hobo_wp_googlebot_tracker_add_dashboard_widgets' );
}
add_action('admin_menu', 'hobo_wp_googlebot_tracker_settings_menu');
add_action('admin_head', 'hobo_wp_googlebot_tracker_admin_header');
add_action('wp_footer', 'hobo_wp_googlebot_tracker_code');
add_action('wp_footer', 'hobo_wp_googlebot_credits');
?>